package fr.wisen.jcmsplugin.ssoplugin;

import java.io.IOException;

import com.jalios.jcms.Member;

public class ActivateLdapHandler extends com.jalios.jcms.handler.EditMemberHandler {

	protected boolean opActivateSyncLdap;

	@Override
	public boolean processAction() throws IOException {
		if (validateActivateSyncLdap()) {
			return performActivateSyncLdap();
		}
		return false;
	}

	public boolean validateActivateSyncLdap() throws IOException {
		if (!this.opActivateSyncLdap)
			return false;

		if (!this.isAdmin) {
			setWarningMsgSession(glp("msg.forbidden", new Object[0]));
			return false;
		}

		if (this.member == null) {
			setWarningMsgSession(glp("msg.member-editor.bad-member-id", new Object[0]));
			return false;
		}

		this.workingMember = (Member) this.member.getUpdateInstance();
		this.workingMember.setLastLdapSynchro(null);
		this.workingMember.setLdapSync(true);
		if (!processStatus(this.workingMember.checkUpdate(this.loggedMember, getControllerContext()))) {
			return false;
		}

		return true;
	}

	public boolean performActivateSyncLdap() throws IOException {
		this.workingMember.performUpdate(this.workingMember);
		sendRedirect();
		return true;
	}

	public void setOpActivateSyncLdap(String paramString) {
		this.op = true;
		this.opActivateSyncLdap = true;
	}

}